((Themify, api, doc, vars, undefined) => {
	'use strict';

	Themify.on( 'tb_edit_component', ( args ) => {
		const slug = args.slug;
		if ( ! [ 'post', 'portfolio', 'products' ].includes( slug ) ) {
			return;
		}

		let layoutOptionIndex = 0;
		args.data.setting.options.forEach( ( option, index ) => {
			if ( option.id && option.id === 'layout_' + slug ) {
				layoutOptionIndex = index + 1;
				const url = vars.theme_url + '/images/layout-icons/';
				if ( slug === 'portfolio' ) {
					option.options.push( { value : 'list-post', label : 'lpost', img : url + 'list-post.png' } );
				}
				option.options.push( { value : 'auto_tiles', label : 'tf_tiles', img : url + 'auto-tiles.png' } );
				option.options.push( { value : 'list-large-image', label : 'tf_ll', img : url + 'list-large-image.png' } );
				option.binding = {
					not_empty : { show : [ slug + '_content_layout', 'disable_masonry', 'post_gutter', 'portfolio_gutter', 'post_filter' ] },
					'list-post' : {
						hide : [ 'masonry', 'disable_masonry', 'post_gutter', 'portfolio_gutter' ],
						show : [ slug + '_content_layout' ]
					},
					auto_tiles : {
						hide : [ 'disable_masonry', 'post_gutter', 'portfolio_gutter', 'ajax_filter' ],
						show : [ slug + '_content_layout' ]
					},
					'list-large-image' : {
						hide : [ slug + '_content_layout', 'disable_masonry', 'post_gutter' ],
						show : [ 'post_filter' ]
					},
					'list-thumb-image' : {
						hide : [ slug + '_content_layout', 'disable_masonry', 'post_gutter' ],
						show : 'masonry'
					},
					'grid2-thumb' : {
						hide : [ slug + '_content_layout' ],
						show : [ 'post_gutter', 'disable_masonry','post_filter' ],
					},
					fullwidth : {
						hide : [ 'disable_masonry', 'portfolio_gutter' ],
						show : [ slug + '_content_layout' ]
					}
				};
			}
		} );

		const newFields = [
			{
				id : slug + '_content_layout',
				type : 'select',
				label : 'tf_conlay',
				options : {
					default : 'def',
					no : 'tf_stack',
					overlay : 'overlay',
					polaroid : 'tf_pl',
					boxed : 'box',
					flip : 'tf_flip'
				}
			},
			{
				id : 'disable_masonry',
				type : 'select',
				label : 'tf_mas',
				options : {
					default : 'def',
					yes : 'y',
					no : 'no'
				},
				wrap_class : 'tb_group_element_grid6 tb_group_element_grid5 tb_group_element_grid4 tb_group_element_grid3 tb_group_element_grid2 tb_group_element_list-large-image'
			}
		];
		if ( slug !== 'products' ) {
			newFields.push( {
				id : slug + '_gutter',
				type : 'select',
				label : 'tf_gut',
				options : {
					default : 'def',
					gutter : 'n',
					'no-gutter' : 'tf_ngut'
				}
			} );
		}
		args.data.setting.options = [
			...args.data.setting.options.slice( 0, layoutOptionIndex ),
			...newFields,
			...args.data.setting.options.slice( layoutOptionIndex )
		];
	} );

})(Themify, tb_app, document, themifyBuilder );