(( doc, vars ) => {

	function loadJSZip() {
		return Themify.loadJs( 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js', !!window.JSZip, false );
	}

	window.addEventListener( 'load', () => {
		const btn = doc.createElement( 'a' );
		btn.className = 'page-title-action';
		btn.href = '#';
		btn.textContent = vars.label;
		btn.tfOn( 'click', ( e ) => {
			e.preventDefault();

			Themify.loadJs( Themify.url+'js/admin/notification',!!window.TF_Notification );
			const fileInput = document.createElement('input');
			fileInput.type = 'file';
			fileInput.accept = '.zip,.txt';
			fileInput.tfOn( 'change', async e => {
				TF_Notification.show( 'info', vars.start );
				e.currentTarget.remove();

				try {
					const file = e.currentTarget.files[0],
						_callback = ( data, gs_data ) => {
							Themify.fetch( {
								action : 'tb_bulk_import',
								_ajax_nonce : vars.nonce,
								data : data,
								gs_data : gs_data
							} ).then( response => {
								if ( response.success ) {
									window.location.reload();
								} else {
									throw Error( vars.error );
								}
							} );
						};
					if ( file.type === 'text/plain' ) {
						const reader = new FileReader();
						reader.tfOn( 'loadend', function(e){
							try {
								if ( this.readyState === FileReader.DONE ) {
									_callback( e.target.result, null );
								}
							}
							catch(e){}
						}, { passive: true, once: true } )
						.readAsText(file);
					} else if ( file.type === 'application/x-zip-compressed' || file.type === 'application/zip' ) {
						await loadJSZip();
						const jsZip  = new JSZip(),
							zip = await jsZip.loadAsync(file),
							files = zip.files;
						if ( files ) {
							if ( files['export_file.txt'] ) {
								const data = await zip.file('export_file.txt').async('text'),
									gs_data = files['builder_gs_data_export.txt'] ? await zip.file('builder_gs_data_export.txt').async('text') : null;
								_callback( data, gs_data );
							} else {
								throw Error( vars.invalid );
							}
						} else {
							throw Error( vars.invalid );
						}
					} else {
						throw Error( vars.invalid );
					}
				}
				catch ( e ) {
					TF_Notification.showHide( 'error', e.message );
				}
			}, { passive:true, once:true } )
			.click();

		} );

		doc.tfClass( 'page-title-action' )[0].after( btn );
	} );

})(document, tbBulkImport);