((api,Themify, doc, topWindow,und) => {
    'use strict';
    const row=doc.tfId('tmpl-builder_row_action').content,
        column=doc.tfId('tmpl-builder_column_action').content,
        subrow=doc.tfId('tmpl-builder_subrow_action').content,
        module=doc.tfId('tmpl-builder_module_action').content,
        toolbarHeight=parseInt(getComputedStyle(doc.body).getPropertyValue('--tb_toolbar_h'));
        
    class Bar extends HTMLElement {
        connectedCallback () {
            const tpl=this.constructor.template.cloneNode(true),
                menu=tpl.querySelector('.dropdown'),
                showTab=(target,type)=>{
                    let root=target.getRootNode(),
                        tabId = target.dataset.href; 
                    if(tabId==='options'){
                        root.querySelector('#'+tabId).classList.add('selected');
                        tabId=root.querySelector('.row_menu .selected');
                        tabId=tabId?.dataset.href || 'grid';
                    }
                    const el=root.querySelector('#'+tabId),
                        grid=root.querySelector('#grid'),
                        cid=root.host.closest('[data-cid]').dataset.cid,
                        hide=tabId === 'grid'?root.querySelector('#row_options'):grid,
                        optionTab=root.querySelector('#options');
                       
                        if(el.childElementCount<2){
                            const model=api.Registry.get(cid);
                            if(model){
                                if (tabId === 'grid') {
                                    model.gridMenu(grid);
                                }
                                else{
                                    model.optionsTab(el);
                                }
                            }
                        }
                        for(let nav=target.parentNode.children,i=nav.length-1;i>-1;--i){
                            nav[i].classList.toggle('selected',nav[i]===target);
                        }
                        el.classList.add('selected');
                        hide?.classList.remove('selected');
                        if(type!=='click' && optionTab!==null){
                            api.Utils.addViewPortClass(optionTab);
                        }
                        
                };
                
                this.attachShadow({ mode:'open'}).appendChild(tpl);
                const ev=this.constructor===ModuleBar && getComputedStyle(menu).getPropertyValue('--tb_bar_is_small').toString().trim()==='1'?'pointerenter':'pointerover';//.trim() is important firefox adds "\n"
                menu.tfOn(ev,e=>{
                        e.stopPropagation();
                        const m=e.currentTarget,
                            root=m.getRootNode(),
                            bodyCl=doc.body.classList,
                            target=e.target,
                            inner_menu=target.classList.contains('more') || target.classList.contains('inner_more')?target.tfClass('menu')[0]:null;
                        
                        if (inner_menu || target.classList.contains('inner_more') || target.classList.contains('menu')) {
                            api.Utils.addViewPortClass((inner_menu?inner_menu:target));
                        }
                        if(target.hasAttribute('data-href')){
                            showTab(target);
                        }
                        else {
                            const tab=root.querySelector('.tab');
                            if(tab!==null){
                                for(let nav=m.children,i=nav.length-1;i>-1;--i){
                                    nav[i].classList.remove('selected');
                                }
                                tab.classList.remove('selected');
                            }
                            else if(!inner_menu && e.type==='pointerenter' && !root.querySelector('.nested_menu') && getComputedStyle(m).getPropertyValue('--tb_bar_is_small').toString().trim()==='1'){
                                
                                let el=m.getRootNode().host.closest('[data-cid]'),
                                    builder=api.Builder.get().el,
                                    ids=[el.dataset.cid],
                                    index=0,
                                    submenu=doc.createElement('ul');
                                while(true){
                                    el = el.parentNode.closest('[data-cid]');
                                    if(!el || !builder.contains(el)){
                                        break;
                                    }
                                    ids.push(el.dataset.cid);
                                }
                                for(let i=0;i<ids.length;++i){
                                    let model = api.Registry.get(ids[i]),
                                        type=model.type,
                                        li = doc.createElement('li'),
                                        lvl;
                                    if(type==='subrow' || type==='row'){
                                        lvl=index-1;
                                    }
                                    else{
                                        if(type==='module'){
                                            lvl=index=0;
                                        }
                                        else {
                                            lvl=index;
                                        }
                                        ++index;
                                    }
                                    li.className='lvl'+lvl;
                                    li.textContent=type==='module'?model.getName():(model.isSubCol?'Sub Column':type);
                                    li.dataset.cid=ids[i];
                                    if(lvl!==0){
                                        li.style.marginInlineStart=(5*lvl)+'px';
                                    }
                                    submenu.appendChild(li);
                                }
                                submenu.tfOn('pointerover',e=>{
                                    if(!this.prevEl){
                                        doc.body.classList.add('tb_nested_hover');
                                    }else{
                                        this.prevEl.classList.remove('tb_current_module');
                                    }
                                    const cid=e.target.dataset.cid;
                                    if(cid){
                                        this.prevEl= api.Registry.get(cid).el;
                                        this.prevEl.classList.add('tb_current_module');
                                    }
                                },{passive:true})
                                .tfOn(Themify.click,async e=>{
                                    e.stopPropagation();
                                    const cid=e.target.dataset.cid;
                                    if(cid){
                                        e.currentTarget.remove();
                                        const model=api.Registry.get(cid),
                                        el=model.type==='subrow'?model.el.tfClass('module_subrow')[0]:model.el,
                                        actionBar=el.querySelector(':scope>.tb_'+model.type+'_action');
                                        await model.edit();
                                        el.classList.add('tb_show_action');
                                        Themify.triggerEvent(actionBar,'pointerover');
                                        api.ActionBar.disable=api.ActionBar.disableClear=true;
                                        if(model.type==='module'){
                                            actionBar.tfClass('tb_bar')[0].classList.add('tb_show_action');
                                        }
                                        setTimeout(()=>{
                                            const disable=e=>{
                                                if(!e || e.button===0){
                                                    api.Builder.get().el.tfOff('pointerdown', disable,{passive:true});
                                                    doc.tfOff('pointerdown', disable,{passive:true});
                                                    topWindow.document.tfOff('pointerdown', disable,{passive:true});
                                                    Themify.off('themify_builder_lightbox_close', disable);
                                                    setTimeout(()=>{
                                                        for (let selected = api.Builder.get().el.tfClass('tb_show_action'),i = selected.length - 1; i > -1; --i) {
                                                            selected[i].classList.remove('tb_show_action');
                                                        }
                                                        api.ActionBar.disableClear=api.ActionBar.disable=null;
                                                    },100);
                                                }
                                            };
                                            api.Builder.get().el.tfOn('pointerdown', disable,{passive:true});
                                            doc.tfOn('pointerdown', disable,{passive:true});
                                            Themify.on('themify_builder_lightbox_close', disable,true);
                                            if(api.isFrontend){
                                                topWindow.document.tfOn('pointerdown', disable,{passive:true});
                                            }
                                        },150);
                    
                                    }
                                },{passive:true})
                                .className='menu more_menu nested_menu tf_box tf_scrollbar';
                                target.appendChild(submenu);
                                api.Utils.addViewPortClass(submenu);
                            }
                        }
                        
                },{passive:true});
                 
                this.shadowRoot.tfOn(Themify.click,function(e){
                    e.stopPropagation();
                    const action=e.target.closest('[data-action]');
                    if(action){
                        let module=api.Registry.get(this.host.closest('[data-cid]').dataset.cid),
                            actionName=action.dataset.action;
                        if(actionName==='edit' || actionName==='styling' || actionName==='visibility' || actionName==='swap'){
                            if(actionName==='edit' && module.type==='module' && this.querySelector('.swap')?.offsetParent){
                                actionName='editBuilder';
                            }
                            module.edit(actionName);
                        }
                        else if(actionName==='add_col'){
                            const to=module.el,
                                col=new api.Column({},module.type==='subrow');
                            api.undoManager.start('move');
                            api.Drop.column(col.el,to,'right').then(()=>{
                                api.undoManager.end('move');
                            });
                        }
                        else if(actionName==='up' || actionName==='down'){
                            const nextEl= actionName==='up'?module.el.previousElementSibling:module.el.nextElementSibling,
                                offset=parseInt(getComputedStyle(doc.querySelector(':root')).getPropertyValue('--tb_toolbar_h'));
                            api.ActionBar.clear();
                            module.el.classList.add('tb_draggable_item');
                            api.undoManager.start('move');
                            actionName==='up'?nextEl.before(module.el):nextEl.after(module.el);
                            Themify.trigger('tb_' + module.type + '_sort', [module.el]);
                            api.undoManager.end('move');
                            module.el.classList.remove('tb_draggable_item');
                            api.Utils.scrollTo(module.el,offset,{behavior:'smooth'});
                        }
                        else if(module[actionName]){
                            module[actionName](actionName==='paste'?e.target.classList.contains('style'):e.target);
                        }
                    }
                    else if(e.target.hasAttribute('data-href')){
                        showTab(e.target,'click');
                    }
                },{passive:true});
               
        }
        disconnectedCallback(){
            doc.body.classList.remove('tb_nested_hover');
            this.prevEl?.classList.remove('tb_current_module');
            this.prevEl=null;
        }
    }
    class RowBar extends Bar {
        static template=row;
    }
    class ColumnBar extends Bar {
        static template=column
    }
    class SubrowBar extends Bar {
        static template=subrow
    }
    class ModuleBar extends Bar {
        static template=module;
    }
    customElements.define('tb-row-bar', RowBar);
    customElements.define('tb-column-bar', ColumnBar);
    customElements.define('tb-subrow-bar', SubrowBar);
    customElements.define('tb-module-bar', ModuleBar);
    
    api.ActionBar =  {
        cid:null,
        disable:null,
        breadCrumbs:null,
        disablePosition:null,

        init() {
            const actionBarCss=module.querySelector('style'),//we are rendreing the inline css ONLY in module bar on the page loading
            fr=doc.createDocumentFragment(),
            gridCss=row.querySelector('#module_row_grids_style'),
            formFields=row.querySelector('#module_form_fields_style'),
            topHead=topWindow.document.head;

            fr.appendChild(api.ToolBar.getBaseCss());
            module.prepend(fr.cloneNode(true));
            fr.appendChild(actionBarCss.cloneNode(true));

            row.prepend(fr.cloneNode(true));

            column.prepend(fr.cloneNode(true));
            fr.appendChild(formFields.cloneNode(true));

            subrow.prepend(fr,gridCss.cloneNode(true));
            if(api.isFrontend){
                topHead.prepend(formFields.cloneNode(true));
            }
            else{
                topHead.appendChild(formFields.cloneNode(true));
            }
            if (api.isGSPage === true) {
                return;
            }
            this.breadCrumbs = doc.createElement('ul');
            this.breadCrumbs.className = 'tb_action_breadcrumb';

            Themify.on('themify_builder_ready',()=>{
                const builder=api.Builder.get().el;


                builder.tfOn(Themify.click, e=>{
                    const target=e.target;
                    if(api.isDocked && target.classList.contains('tb_dragger')){
                        e.preventDefault();
                        e.stopPropagation();
                        api.EdgeDrag.openLightBox(target);
                        return;
                    }
                    if(target.closest('.tb_visibility_hint,.tb_row_info')){
                        const model=api.Registry.get(target.closest('[data-cid]').dataset.cid);
                        if(target.closest('.tb_visibility_hint')){
                            model.edit('visibility');
                        }
                        else{
                            model.edit().then(lb=>{
                                const cssField=lb.querySelector('.tb_field_group_css .tb_style_toggle.tb_closed');
                                if(cssField){
                                    Themify.triggerEvent(cssField, e.type);
                                }
                            })
                            .catch(()=>{

                            });
                        }
                        return;
                    }
                    this.click(e);

                })
                .tfOn('pointerover', e=>{
                    e.stopPropagation();
                    this.hover(e);
                },{passive: true});
                if(!Themify.isTouch){
                    builder.tfOn('pointerleave', e=>{
                        if(e.relatedTarget!==e.currentTarget.ownerDocument.body){
                            this.clear();
                        }
                    },{passive: true})
                    .tfOn('dblclick', e=>{
                        const target = e.target,
                            tagName = target.tagName;
                        if(!doc.activeElement.isContentEditable && tagName !== 'INPUT' && tagName !== 'TEXTAREA'){
                            if(tagName==='DIV' &&target.classList.contains('tb_dragger')){
                                api.EdgeDrag.openLightBox(target);
                            }
                            else if(!api.isDocked){
                                const el = target.closest('[data-cid]');
                                if(el){
                                    e.preventDefault();
                                    const model = api.Registry.get(el.dataset.cid),
                                    actionBar=model.el.tfTag('tb-'+model.type+'-bar')[0];
                                    if(model.isEmpty!==true){
                                        if(actionBar){
                                            if(!actionBar.contains(target)){
                                                const editBtn=actionBar.shadowRoot.querySelector('.edit');
                                                if(editBtn){
                                                    Themify.triggerEvent(editBtn,Themify.click);
                                                }
                                            }
                                        }
                                        else{
                                            this.click(e);
                                        }
                                    }
                                }
                            }
                        }
                    });
                    if(!themifyBuilder.disableShortcuts){
                        const canvas = api.isFrontend ? null : doc.tfId('tb_canvas_block');

                        if (canvas === null) {
                            doc.tfOn('keydown', e=>{
                                this.actions(e);
                            });
                            topWindow.document.tfOn('keydown', e=>{
                                this.actions(e);
                            });
                        } else {
                            canvas.tfOn('keydown', e=>{
                                this.actions(e);
                            });
                        }
                    }
                }
            }, true,api.is_builder_ready);
        },
        async actions(e) {
            const target = e.target,
                tagName = target.tagName;
                if (tagName !== 'INPUT' && tagName !== 'TEXTAREA' && !doc.activeElement.isContentEditable && !api.LightBox.el.contains(target)  && (!api.isFrontend ||!api.liveStylingInstance?.el?.contains(doc.activeElement))) {
                    const code = e.code,
                        items = api.Builder.get().el.tfClass('tb_element_clicked');
                    let len = items.length;
                    if (len > 0) {
                        let act=e.action,
                            pasteStyle=true;
                        if(!act){
                            if (code === 'Delete') {
                                act = 'delete';
                            } 
                            else if (e.ctrlKey === true || e.metaKey === true) {
                                if (code === 'KeyC') {
                                    act = 'copy';
                                } 
                                else if (code === 'KeyD') {
                                    act = 'duplicate';
                                } 
                                else if (code === 'KeyV') {
                                    act = 'paste';
                                }
                            }
                        }
                        if(act){
                            if(act==='copy'){
                                len=1;
                            }
                            else if(act==='paste'){
                                pasteStyle = e.shiftKey === true;
                            }
                            if(typeof e.preventDefault==='function'){
                                e.preventDefault();
                                e.stopPropagation();
                            }
                            if(act === 'delete' || act === 'paste'){
                                await api.LightBox.save();
                            }
                            const proms=[];
                            api.undoManager.start(act);
                            for (let i = len - 1; i > -1; --i) {
                                let selected = items[i].closest('[data-cid]');
                                if(selected!==null){
                                    let el=api.Registry.get(selected.dataset.cid);
                                    if(el){
                                        proms.push(el[act](pasteStyle,true));
                                    }
                                }
                            }
                            if (act === 'delete') {
                                this.clear();
                            }
                            try{
                                await Promise.all(proms);
                            }
                            catch (e){

                            }
                            api.undoManager.end(act);
                        }
                    }
                }
        },
        columnHover(el) {
            let subColumn = el.closest('.sub_column'),
                col = subColumn!== null ? subColumn.parentNode.closest('.module_column'):el.closest('.module_column'),
                row = col?.closest('.module_row') || el.closest('.module_row'),
                items = api.Builder.get().el.querySelectorAll('.tb_hide_drag_left,.tb_hide_drag_right');
            for (let i = items.length - 1; i > -1; --i) {
                items[i].classList.remove('tb_hide_drag_left', 'tb_hide_drag_right');
            }
            if (col !== null || subColumn !== null) {
                const cols = [col, subColumn],
                    offset=api.isVisual?3:13;
                for (let i = cols.length - 1; i > -1; --i) {
                    if (cols[i] !== null) {
                        let left = cols[i].offsetLeft;
                        if (left<=offset) {
                            cols[i].classList.add('tb_hide_drag_left');
                        }
                        if ((left + cols[i].offsetWidth+offset) >= cols[i].parentNode.offsetWidth) {
                            cols[i].classList.add('tb_hide_drag_right');
                        }
                    }
                }
            }
            if (api.isVisual && this.isFullWidth !== true) {
                if (row !== null && this.isFullWidth !== false) {
                    this.isFullWidth = row.offsetWidth < document.body.clientWidth;
                    document.body.classList.toggle('tb_page_row_fullwidth', !this.isFullWidth);
                }
                if (col?.parentNode.parentNode.closest('.fullwidth')) {
                    const columnAction = col.querySelector(':scope>.tb_column_action');
                    if (columnAction?.getBoundingClientRect().right >= document.body.clientWidth) {
                        columnAction.classList.add('tb_action_outside');
                    }
                }
            }
        },
        hover(e) {
            if (api.isPreview!==true && !doc.body.classList.contains('tb_start_animate') && this.disable === null && e.target.id!=='tb_small_toolbar_root') {
                this.columnHover(e.target);
                if (this.disablePosition === null) {
                    const el=e.target.closest('[data-cid]');
                    if(el!==null && !el.classList.contains('tb_active_layout_part')){
                        const cid=el.dataset.cid,
                            model = api.Registry.get(cid);
                        if(this.cid!==cid){
                            this.clear();
                            const actionBar=model.type==='module'?el.querySelector(':scope > .tb_'+model.type+'_action'):(e.target.classList.contains('tb_action_wrap')?e.target:null);
                            if (actionBar) {
								this.cid=cid;
								let slug=  model.get('mod_name');
								if(slug==='row' && model.el.classList.contains('tb-page-break')){
									actionBar.className+=' tb_move';
									slug='page_break';
								}
								const t = doc.createElement('tb-'+model.type+'-bar'),
                                        actionWrap=actionBar.tfClass('tb_action_wrap')[0];
								t.className='tb_bar tb_bar_'+slug;
								if(model.isEmpty===true){
									t.className=' tb_disabled_module';
								}
								else if(model.isSubCol===true){
									t.className+=' tb_bar_sub_column';
								}
                                else if(slug==='row'){
                                    let p=el.parentNode,
                                        last=p.lastElementChild.previousElementSibling;
                                    while(!last.classList.contains('module_row')){
                                        last=last.previousElementSibling;
                                    }
                                    if(el===p.firstElementChild){
                                        t.className+=' tb_row_first';
                                    }
                                    if(el===last){
                                        t.className+=' tb_row_last';
                                    }
								}
								if(api.activeBreakPoint!=='desktop'){
									t.className+=' tb_bar_responsive_mode';
								}
								actionBar.style.marginTop='';
								actionBar.id='tb_component_bar';
                                if(actionWrap!==und){
                                    actionWrap.replaceWith(t);
                                }else{
                                    actionBar.appendChild(t);
                                }
                                api.Utils.addViewPortClass(t.shadowRoot.querySelector('.dropdown'));
                                /*
								if (model.type === 'module') {
									const rect = el.getBoundingClientRect();
									if (rect.height < 70) {
										const cl = t.shadowRoot.querySelector('.wrap,.dropdown').classList,
                                            a_top = actionBar.getBoundingClientRect().top;
										//cl.toggle('small_bottom',!(a_top < 40 || (a_top - api.Builder.get().el.getBoundingClientRect().top) < 40));
									}
								}*/
							}
                        }
                        if (api.isVisual) {
                            api.EdgeDrag.addEdges(model);
                        }
                    }
                    else{
                        this.clear();
                    }
                }
            }
        },
        click(e) {
            if (api.isPreview || this.disable === true || e.target.closest('.tb_disable_sorting,.tb_grid_drag')!==null) {
                return true;
            }
            const target = e.target,
                el = target.closest('[data-cid]');
            if(!el || (target.tagName.indexOf('-')!==-1 && !target.closest('.module'))){
                return;
            }
            e.preventDefault();
            const model = api.Registry.get(el.dataset.cid);
            if(model && model.isEmpty!==true){
                if(e.ctrlKey===true || e.metaKey===true){
                    el.classList.toggle('tb_element_clicked');
                }
                else if ((e.type==='dblclick' || api.isDocked) && !el.classList.contains('tb_active_layout_part')) {
                    model.edit();
                }
            }
        },
        clear() {
            if(this.disableClear!==true){
                for(let bars = api.Builder.get().el.querySelectorAll('#tb_component_bar'),i=bars.length-1;i>-1;--i){
                    let last=bars[i].lastChild;
                    bars[i].removeAttribute('id');
                    if(last.tagName!=='SVG'){
                        last.remove();
                    }
                }
                this.cid=null;
            }
        },
        clearClicked() {
            if(this.disableClear!==true){
                for (let selected = api.Builder.get().el.querySelectorAll('.tb_element_clicked,.tb_current_module'),i = selected.length - 1; i > -1; --i) {
                    selected[i].classList.remove('tb_element_clicked','tb_current_module');
                }
            }
        }
    };
    Themify.on('tb_toolbar_loaded', () => {
            api.ActionBar.init();
    }, true,(api.ToolBar!==und && api.ToolBar.isLoaded===true));
    
})(tb_app,Themify, document, window.top,undefined);