((api, topWindow,doc, und) => {
    'use strict';
    //hack to detect the row_inner/module_subrow width to convert old padding/margin(in percent only) of cols to new grid padding/margin pergin percent(https://www.w3.org/TR/css3-grid-layout/#item-margins)
    api.correctColumnPaddings = () => {
        return new Promise(resolve => {
            if (!api.isVisual) {
                resolve();
                return;
            }
            const cols = api.Builder.get().el.tfClass('module_column'),
                    len = cols.length,
                    styleObject=ThemifyStyles;
            if (len > 0) {
                const colPaddingsIds = ['padding_top', 'padding_bottom', 'padding_left', 'padding_right', 'margin-bottom', 'margin-top'],
                        points = api.breakpointsReverse,
                        bpLength = points.length,
                        elements = {},
                        checkPaddings = (bpStyles, allStyles, bp) => {
                    const found = {};
                    for (let i = colPaddingsIds.length - 1; i > -1; --i) {
                        let prop = colPaddingsIds[i],
                                p = bpStyles[prop];
                        if (p !== '' && p !== und && !p.toString().includes(',') && styleObject.getStyleVal(prop + '_unit', allStyles, bp) === '%') {
                            found[prop] = p;
                        }
                    }
                    return found;
                };

                for (let i = cols.length - 1; i > -1; --i) {
                    let id = cols[i].dataset.cid,
                            model = api.Registry.get(id);
                    if (model) {
                        let st = model.get('styling');
                        if (st !== und) {
                            for (let j = bpLength - 1; j > -1; --j) {
                                let bp = points[j],
                                        vals = bp === 'desktop' ? st : st['breakpoint_' + bp];
                                if (vals) {
                                    let found = checkPaddings(vals, st, bp);
                                    if (Object.keys(found).length > 0) {
                                        if (elements[bp] === und) {
                                            elements[bp] = {};
                                        }
                                        elements[bp][id] = found;
                                    }
                                }
                            }
                            //duplicate css values in breakpoints,because if we have mobile 5% and tablet 5%, after converting they can be different value,because the row_inner/cols widths are different in mobile and tablet
                            for (let j = bpLength - 2; j > -1; --j) {
                                let bp = points[j];
                                if (elements[bp] === und || elements[bp][id] === und) {
                                    for (let k = j + 1; k < bpLength; ++k) {
                                        if (elements[points[k]] !== und && elements[points[k]][id] !== und) {
                                            if (elements[bp] === und) {
                                                elements[bp] = {};
                                            }
                                            elements[bp][id] = {...elements[points[k]][id]};
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                if (Object.keys(elements).length === 0) {
                    resolve();
                    return;
                }
                //TF_Notification.show('info',themifyBuilder.i18n.convertingOldData);
                let tmpIframe = doc.createElement('iframe');
                tmpIframe.id = 'tb_regenerate_css_iframe';
                tmpIframe.style.setProperty('position', 'fixed', 'important');
                tmpIframe.style.setProperty('top', '-100000000px', 'important');
                tmpIframe.style.setProperty('left', '-100000000px', 'important');
                tmpIframe.style.setProperty('visibility', 'hidden', 'important');
                tmpIframe.style.setProperty('min-width', 'auto', 'important');
                tmpIframe.style.setProperty('max-height', 'none', 'important');
                tmpIframe.style.setProperty('min-height', 'auto', 'important');
                tmpIframe.style.setProperty('contain', 'none', 'important');
                tmpIframe.style.setProperty('width', '100%', 'important');
                tmpIframe.style.setProperty('height', '100%', 'important');
                tmpIframe.style.setProperty('opacity', '0', 'important');
                tmpIframe.src = 'about:blank';
                tmpIframe.className = 'tb_iframe';
                topWindow.document.body.appendChild(tmpIframe);
                let iframeW = tmpIframe.contentWindow.document,
                        clone = doc.documentElement.cloneNode(true);
                const allScripts = clone.querySelectorAll('script'),
                        breakpoints = api.breakpointsReverse;
                for (let i = allScripts.length - 1; i > -1; --i) {
                    allScripts[i].remove();
                }

                iframeW.open();
                iframeW.write('<!DOCTYPE html>' + clone.outerHTML);
                for (let i = breakpoints.length - 1; i > -1; --i) {
                    let stName = styleObject.styleName + breakpoints[i],
                            rules = styleObject.getSheet(breakpoints[i]).cssRules,
                            globalRules = styleObject.getSheet(breakpoints[i], true).cssRules,
                            sheet = tmpIframe.contentWindow.document.querySelector('#' + stName).sheet,
                            globalSheet = tmpIframe.contentWindow.document.querySelector('#' + stName + '_global').sheet;
                    for (let j = 0, len = globalRules.length; j < len; ++j) {
                        globalSheet.insertRule(globalRules[j].cssText);
                    }
                    for (let j = 0, len = rules.length; j < len; ++j) {
                        sheet.insertRule(rules[j].cssText);
                    }
                }
                clone = null;
                const stData = doc.createElement('style');
                stData.textContent = 'html,body,body *,div,a{transition:none!important;animation:none!important;pointer-events:none!important}';
                tmpIframe.contentWindow.document.body.appendChild(stData);

                tmpIframe.tfOn('load', function () {
                    iframeW = null;

                    const windowW = topWindow.innerWidth + 5,
                            cl = this.contentWindow.document.body.classList,
                            bpLength = breakpoints.length;
                    cl.add('tb_start_animate');

                    for (let i = bpLength - 1; i > -1; --i) {
                        let bp = breakpoints[i];
                        if (elements[bp] !== und) {
                            let iframeSt = 'max-width',
                                    width = bp === 'desktop' ? null : 1 * api.Utils.getBPWidth(bp),
                                    sheet = styleObject.getSheet(bp);
                            if (!width || width >= windowW) {
                                iframeSt = 'min-width';
                                if (!width) {
                                    width = api.Utils.getBPWidth('tablet_landscape') + 1;
                                    if (width < windowW) {
                                        width = '';
                                    }
                                }
                                if (width === windowW) {
                                    --width;
                                }
                            }
                            cl.remove('builder-breakpoint-mobile', 'builder-breakpoint-tablet', 'builder-breakpoint-tablet_landscape');
                            if (bp !== 'desktop') {
                                cl.add('tb_responsive_mode', 'builder-breakpoint-' + bp);
                            } else {
                                cl.remove('tb_responsive_mode');
                            }
                            this.style.setProperty('max-width', 'none', 'important');
                            this.style.setProperty('min-width', 'auto', 'important');
                            if (width) {
                                this.style.setProperty(iframeSt, width + 'px', 'important');
                            }

                            for (let elementId in elements[bp]) {
                                let model = api.Registry.get(elementId),
                                        selector = styleObject.getBaseSelector(model.type, elementId),
                                        col = tmpIframe.contentWindow.document.querySelector(selector),
                                        styles = model.get('styling'),
                                        index = api.Utils.findCssRule(sheet.cssRules, selector),
                                        position = getComputedStyle(col).getPropertyValue('position');
                                if (position === 'absolute' || position === 'fixed') {
                                    continue;
                                }
                                col.style.setProperty('padding', '0', 'important');
                                let innerW = col.parentNode.getBoundingClientRect().width,
                                        colW = col.getBoundingClientRect().width;
                                for (let propId in elements[bp][elementId]) {
                                    let value = elements[bp][elementId][propId],
                                            prop = propId.replace('_', '-'),
                                            v = parseFloat(((parseFloat(value) / 100) * innerW) / colW) * 100;
                                    v = parseFloat(parseFloat(v.toFixed(2))).toString();
                                    if (bp === 'desktop') {
                                        if (styles[propId] !== und && styles[propId].toString().includes(',')) {
                                            continue;
                                        }
                                        if (styles[propId] === und) {
                                            styles[propId] = '';
                                        }
                                        styles[propId] += ',' + v;
                                    } else {
                                        if (styles['breakpoint_' + bp] !== und && styles['breakpoint_' + bp][propId] !== und && styles['breakpoint_' + bp][propId].toString().includes(',')) {
                                            continue;
                                        }
                                        if (styles['breakpoint_' + bp] === und) {
                                            styles['breakpoint_' + bp] = {};
                                        }
                                        if (styles['breakpoint_' + bp][propId] === und) {
                                            styles['breakpoint_' + bp][propId] = '';
                                        }
                                        styles['breakpoint_' + bp][propId] += ',' + v;
                                    }
                                    if (propId[0] !== 'p') {
                                        if (index !== false && sheet.cssRules[index] !== und) {
                                            sheet.cssRules[index].style.setProperty(prop, v + '%');
                                        } else {
                                            sheet.insertRule(selector + '{' + prop + ':' + v + '%}', sheet.cssRules.length);
                                        }
                                    } else {
                                        col.style.padding = '';
                                        let exist = index !== false && sheet.cssRules[index] !== und,
                                                isAllChecked = exist === true ? sheet.cssRules[index].style.getPropertyValue('padding') : tmpIframe.contentWindow.getComputedStyle(col).getPropertyValue('padding');
                                        col.style.setProperty('padding', '0', 'important');

                                        if (isAllChecked && elements[bp][elementId].padding_top !== und && !isAllChecked.includes(' ')) {
                                            v = elements[bp][elementId].padding_top;
                                            v = parseFloat(((parseFloat(v) / 100) * innerW) / colW) * 100;
                                            v = parseFloat(parseFloat(v.toFixed(2))).toString();
                                            prop = 'padding';
                                        }
                                        if (exist === true) {
                                            sheet.cssRules[index].style.setProperty(prop, v + '%');
                                        } else {
                                            sheet.insertRule(selector + '{' + prop + ':' + v + '%}', sheet.cssRules.length);
                                        }
                                    }


                                }
                                model.set('styling', styles);
                            }
                        }
                    }
                    this.remove();
                    tmpIframe = null;
                    //      TF_Notification.showHide('done',themifyBuilder.i18n.oldDataConverted);
                    resolve();
                }, {
                    passive: true,
                    once: true
                });
                iframeW.close();

            } else {
                resolve();
            }
        });
    };
})(tb_app, window.top,document, undefined);