((api, Themify, doc,Node,builderData) => {
        const DragFile=()=>{
            let isWorking=false;
            const ext=builderData.ext,
                allowed={
                    application:{
                        'x-zip-compressed':'zip|',
                        json:'json|'
                    },
                    text:{
                        plain:'txt|'
                    },
                    image:ext.image || {},
                    video:ext.video || {},
                    audio:ext.audio || {}
                },
                formatHtml=html=>{
                        const tmp=doc.createElement('template'),
                            voidTags=/^(?:area|br|col|embed|hr|img|input|meta|param|track|base|source|wbr)$/i,
                            defStyles={
                                height:'auto',
                                width:'auto',
                                whiteSpace:'normal',
                                wordSpacing:'0px',
                                textIndent:'0px',
                                textTransform:'none',
                                overflow:'visible',
                                fontVariantLigatures:'normal',
                                fontVariantCaps:'normal',
                                'font-variant-east-asian':'normal',
                                'font-variant-numeric':'normal',
                                'font-variant-alternates':'normal',
                                'font-feature-settings':'normal',
                                'font-variation-settings':'normal',
                                'font-kerning':'auto',
                                '-webkit-text-stroke-width':'0px'
                            };
                        if(!Themify.isRTL){
                            defStyles.textAlign='left';
                        }
                        tmp.innerHTML=html.replaceAll('<!--StartFragment-->','').replaceAll('<!--EndFragment-->','').trim();
                        const content=tmp.content;
                        if(content.firstChild.nodeType===Node.TEXT_NODE && content.firstChild.textContent==='\n\n'){
                            content.firstChild.remove();
                        }
                        if(content.lastChild.nodeType===Node.TEXT_NODE && content.lastChild.textContent==='\n\n'){
                            content.lastChild.remove();
                        }
                        if(content.firstChild.nodeType===Node.COMMENT_NODE){
                            content.firstChild.remove();
                        }
                        if(content.lastChild.nodeType===Node.COMMENT_NODE){
                            content.lastChild.remove();
                        }
                       for(let allItems=content.querySelectorAll('*'),i=allItems.length-1;i>-1;--i){
                            let node=allItems[i],
                                tagName=node.tagName;
                            if(tagName==='SCRIPT' || tagName==='TEMPLATE' || tagName==='NOSCRIPT' || tagName==='STYLE' || tagName==='LINK' || node.nodeType === Node.COMMENT_NODE || node.style.display==='none' || (node.type==='hidden' && tagName==='INPUT')|| (node.childNodes.length===0 && tagName.indexOf('-')!==-1)){
                                node.remove();
                            }
                       }
                       let dummy=doc.createElement('div');
                       dummy.className='tf_abs_t tf_opacity tf_hidden tf_rel tb_dummy_html';
                       dummy.style.top='-10000px';
                       dummy.appendChild(tmp.content);
                       doc.body.appendChild(dummy);
                       for(let allItems=dummy.children,i=allItems.length-1;i>-1;--i){//remove position absolutes
                           let st=allItems[i].style;
                           if(st.position==='absolute'){
                               st.top=st.left=st.right=st.bottom='';
                               st.position='relative';
                           }
                       }
                       for(let allItems=dummy.tfTag('*'),i=allItems.length-1;i>-1;--i){//remove empty tags
                            let node=allItems[i],
                                st=node.style,
                                prevSt=st.display || '';
                            if(prevSt!=='grid' && prevSt!=='inline-grid'){
                                st.display='flex';
                            }
                            if(!node.offsetWidth || !node.offsetHeight){
                                node.remove();
                            }
                            else{
                                for(let attr=node.attributes,j=attr.length-1;j>-1;--j){
                                   let n=attr[j].name;
                                   if(n==='class' || n==='id' || n.indexOf('data-')===0 || n.indexOf('on')===0 || n==='contenteditable' || n==='draggable' || n==='nonce' || n==='autofocus' || n==='dir' || n==='inert' || n==='tabIndex'){
                                       node.removeAttribute(n);
                                   }
                                }
                                st.display=prevSt;
                                st.opacity=st.direction=st.contentVisibility=st.widows=st.orphans=st.transition='';
                                if(defStyles.textAlign){
                                    st.textAlign='';
                                }
                                for(let j in defStyles){
                                    if(st[j]===defStyles[j]){
                                        st[j]='';
                                    }
                                }
                                let tagName=node.tagName,
                                    stVals=[];
                                if(tagName==='DIV' || tagName==='SPAN' || tagName==='A'){
                                    if(st.padding==='0' || st.padding==='0px'){
                                        st.padding='';
                                    }
                                    if(st.margin==='0' || st.margin==='0px'){
                                        st.margin='';
                                    }
                                }
                                if(!st.backgroundImage.includes('http') && !st.backgroundImage.includes('data:image/')){
                                    st.backgroundImage=st.backgroundAttachment=st.backgroundPosition=st.backgroundRepeat=st.backgroundOrigin=st.backgroundSize=st.backgroundClip='';
                                }
                                if(st.cssText){
                                    let cssText=st.cssText.split('; ');
                                    for(let j=0;j<cssText.length;++j){
                                        let v=cssText[j],
                                            index = v.indexOf(':'),
                                            prop = v.substring(0, index).trim(),
                                            val = v.substring(index + 1).trim();
                                        if (val[val.length - 1] === ';') {
                                            val = val.slice(0, -1);
                                        }
                                        if(val!=='initial'&& prop.indexOf('animation')!==0){
                                            if(val.indexOf('rgb')===0){
                                                val=ThemifyStyles.rgbToHex(val);
                                            }
                                            else if(val==='0px'){
                                                val='0';
                                            }
                                            else if(!val.includes('calc')){
                                                val=val.replace(/\b(?:0px|0%|0em|0fr)/g, '0');
                                            }
                                            stVals.push(prop+':'+val.replace(/\s0\./g, ' .').replace(/\s\s+/g, ' ').replace(/\.+0*?fr/g, 'fr').replace(/\.+0*?\%/g, '%').replace(/\.+0*?em/g, 'em').replace(/\.+0*?px/g, 'px'));
                                        }
                                    }
                                    if(stVals.length>0){
                                        node.setAttribute('style',stVals.join(';'));
                                    }else{
                                        node.removeAttribute('style');
                                    }
                                }
                            }
                       } 
                       const row=new api.Row({
                            cols: [{
                                    grid_class: 'col-full',
                                    element_id: api.Helper.generateUniqueID(),
                                    modules: [
                                        {
                                            mod_name: 'text'
                                        }
                                    ]
                            }]
                        }),
                        options={
                            position:'absolute',
                            top:'-10000px',
                            left:'0',
                            width:'100%',
                            visibility:'hidden',
                            opacity:'0'
                        },
                        activeModule=row.el.tfClass('active_module')[0],
                        moduleText=api.Registry.get(activeModule.dataset.cid);
                        activeModule.appendChild(moduleText.preview({content_text: dummy.outerHTML}));
                        dummy.remove();
                        dummy=activeModule.tfClass('tb_dummy_html')[0];
                        for(let prop in options){
                            row.el.style.setProperty(prop,options[prop],'important');
                        }
                        api.Builder.get().el.appendChild(row.el);
                        for(let allItems=dummy.tfTag('*'),i=allItems.length-1;i>-1;--i){//change width px to %
                            let node=allItems[i],
                                st=node.style,
                                parent=node.parentNode,
                                parentSt=parent;
                            if(parent!==dummy && st.width && parentSt.display!=='grid' && parentSt.display!=='inline-grid'){
                                let w=parseFloat((parseFloat(st.width)/parent.offsetWidth)*100);
                                if(w>100){
                                    w=100;
                                }
                                st.width=w+'%';
                            }
                        }
                        row.destroy(true);
                        return dummy.innerHTML;
                },
            uploadHandler=async dataTransfer=>{
                let plainText=dataTransfer.getData('text/plain')?.trim() || '',
                files=dataTransfer.files;
                if(plainText || files?.length>0){
                    isWorking=true;
                    const upload={
                        application:[],
                        image:[],
                        video:[],
                        audio:[]
                    };
                    if(files?.length>0){
                        for (let i=files.length-1; i>-1;--i) {
                            let [type,ext]=files[i].type.split('/');
                            ext=ext?.toLowerCase();
                            let f=allowed[type] && files[i].size>0?(allowed[type][ext] || allowed[type]['x-'+ext]):null;
                            if(f){
                                let k=type==='text'?'application':type,
                                    fext=files[i].name.split('.').pop().toLowerCase();
                                if(f.includes(fext+'|')){
                                    upload[k].push(files[i]);
                                }
                            }
                        }
                    }
                    if(upload.application.length>0){
                        let zips=upload.application,
                            builderExport=zips[0];
                        for(let i=zips.length-1;i>-1;--i){
                            if(zips[i].name.includes('themify_builder')){
                                builderExport=zips[i];
                                break;
                            }
                        }
                        await api.ToolBar.initImport({target:doc.createElement('div')});
                        await TB_Import.fileImport(builderExport);
                    } 
                    else{
                        let settings,
                        module='plain-text',
                        memory=parseInt(builderData.memory) || 64,
                        chunkSize=memory>=255?4:(memory>=120?3:(memory>60?2:1)),
                        images=upload.image,
                        video=upload.video,
                        audio=upload.audio;
                        if(images.length>0 || video.length>0 || audio.length>0){
                            await Themify.loadJs(Themify.url+'js/admin/import/import-images',!!window.TF_ImportImages);
                            const res=await TF_ImportImages.init(images.concat(video,audio),builderData.nonce,builderData.i18n.uploading,chunkSize);
                            TF_Notification.showHide('done','',1000);
                            if(!api.activeModel && !doc.activeElement.isContentEditable){
                                const resImage=[],
                                    resVideo=[],
                                    resAudio=[];
                                for(let i=images.length-1;i>-1;--i){
                                    let v=res.get(images[i].name);
                                    if(v?.id){
                                        v.name=images[i].name;
                                        resImage.push(v);
                                    }
                                }
                                for(let i=video.length-1;i>-1;--i){
                                    let v=res.get(video[i].name);
                                    if(v?.id){
                                        v.name=video[i].name;
                                        resVideo.push(v);
                                    }
                                }
                                for(let i=audio.length-1;i>-1;--i){
                                    let v=res.get(audio[i].name);
                                    if(v?.id){
                                        v.name=audio[i].name;
                                        resAudio.push(v);
                                    }
                                }
                                const max=Math.max(resImage.length,resVideo.length,resAudio.length);
                                if(max>0){
                                    const  getIds=arr=>{
                                        const ids=[];
                                        for(let i=0;i<arr.length;++i){
                                            ids.push(arr[i].id);
                                        } 
                                        return ids;
                                    };
                                    if(resImage.length===max){
                                        if(max>1){
                                            settings={shortcode_gallery:'[gallery ids="'+getIds(resImage).join(',')+'"]'};
                                            module='gallery';
                                        }
                                        else{
                                            const item=resImage[0];
                                            settings={url_image:item.src,title_image:item.name.substring(0, item.name.lastIndexOf('.'))};
                                            module='image';
                                        }
                                    }
                                    else if(resVideo.length===max){
                                        if(max>1){
                                            settings={plain_text:'[playlist type="video" ids="'+getIds(resVideo).join(',')+'"]'};
                                        }
                                        else{
                                            const item=resVideo[0];
                                            settings={url_video:item.src,title_video:item.name.substring(0, item.name.lastIndexOf('.'))};
                                            module='video';
                                        }
                                    }
                                    else{
                                        if(false && api.Module.getModuleClassName('audio')){
                                            module='audio';
                                            settings={music_playlist:[]};
                                            for(let i=0;i<resAudio.length;++i){
                                                settings.music_playlist.push({
                                                    audio_name:resAudio[i].name,
                                                    audio_url:resAudio[i].src
                                                });
                                            }
                                        }
                                        else{
                                            settings={plain_text:'[playlist type="audio" ids="'+getIds(resAudio).join(',')+'"]'};
                                        }
                                    }
                                }
                            }
                        }
                        else if(plainText){
                            let html=dataTransfer.getData('text/html')?.trim() || '';
                            if(html && plainText!==html){
                                const i18n=builderData.i18n,
                                opt = {
                                    msg: i18n.paste_plain_text
                                },
                                answer=await api.LiteLightBox.confirm(opt);
                                if(!answer){
                                    return;
                                }
                                if(answer==='no'){
                                    settings={content_text:formatHtml(html)};
                                    module='text';
                                }
                                else{
                                    html='';
                                }
                            }
                            else{
                                html='';
                            }
                            if(!html){
                                settings={plain_text:plainText};
                            }
                        }
                        if(settings){
                            try{
                                await api.MainPanel.newModule(module,true,settings);
                            }
                            catch(e){
                            }
                        }
                    }
                    isWorking=false;
                }
            },
            paste=e=>{
                const target=e.composedPath()[0] || e.target;
                if(!target.isContentEditable && !api.isPreview && target.tagName!=='INPUT'&& target.tagName!=='TEXTAREA' && !doc.activeElement.isContentEditable){
                    uploadHandler(e.clipboardData);
                }
            };
            
            if(allowed.audio.mpeg?.includes('m4a|')){
                allowed.audio['x-m4a']='m4a|';
            }
            if(allowed.audio.mpeg?.includes('m4b|')){
                allowed.audio['x-m4b']='m4b|';
            }
            let isBind=false;
            doc.tfOn('dragenter', e=>{
                const items=e.dataTransfer.items;
                if (isWorking===false && !api.isPreview && items && e.target && e.target.id!=='tb_drop_zone' && !doc.body.classList.contains('tb_start_animate')) {
                    let found=false;
                    for (let i=items.length-1; i>-1;--i) {
                        let kind=items[i].kind;
                        if(kind==='file'){
                            let [type,ext]=items[i].type.split('/');
                            ext=ext?.toLowerCase();
                            if(allowed[type] && (allowed[type][ext] || allowed[type]['x-'+ext])){
                                found=true;
                                break;
                            }
                        }
                        else if(kind==='string'){
                            found=true;
                            break;
                        }
                    }
                    if(found===true){
                        e.stopPropagation();
                        const dropZone=doc.tfId('tb_drop_zone'),
                            leave=e=>{
                                e.stopPropagation();
                                doc.body.classList.remove('tb_drop_file');  
                            };
                        if(isBind===false){
                            isBind=true;
                            const dragOver=e=>{
                                e.stopPropagation();
                                e.preventDefault();
                                e.dataTransfer.dropEffect = 'copy';
                            },
                            dragEnd=e=>{
                                e.stopPropagation();
                                dropZone.tfOff('drop',drop,  {once:true})
                                .tfOff('dragleave',leave,  {passive:true,once:true})
                                .tfOff('dragover',dragOver);
                                doc.tfOff('dragend',dragEnd,  {passive:true,once:true});
                                leave(e);
                                isBind=false;
                            },
                            drop=e=>{
                                e.stopPropagation();
                                e.preventDefault();
                                dragEnd(e);
                                uploadHandler(e.dataTransfer);
                            };
                            dropZone.tfOn('dragover',dragOver)
                                .tfOn('drop',drop,{once:true});
                            doc.tfOn('dragend',dragEnd,  {passive:true,once:true});
                        }
                        dropZone.tfOn('dragleave',leave,  {passive:true,once:true});
                        doc.body.classList.add('tb_drop_file');
                    }
                }
            }, {passive:true})
            .tfOn('paste', paste,{passive:true});
            if(api.isFrontend){
                window.top.document.tfOn('paste', paste,{passive:true});
            }
        };
        DragFile();
})(tb_app, Themify, document,Node,themifyBuilder);