((api, Themify, doc,win,TF_Notification,themifyBuilder) => {
    'use strict';
    win.tfOn('offline', () => {
        setTimeout(()=>{
            if(!win.navigator.onLine && !api.Builder.get().isSaved && api.undoManager.hasUndo()){
                const saveBtnCl=api.ToolBar.el.tfClass('save_wrap')[0].classList,
                msgWrap=doc.createElement('div'),
                exportJson=e=>{
                    if(e.composedPath()[0].closest('a')){
                        e.preventDefault();
                        e.stopImmediatePropagation();
                        e.currentTarget.tfOff(e.type,exportJson,{once:true});
                        let builder=api.Builder.get(),
                            json=builder.toJSON(true),
                            customCss=builder.customCss,
                            postTitle=themifyBuilder.post_title,
                            date=new Date(),
                            currentData=date.getFullYear()+'_'+date.getMonth()+'_'+date.getDate(),
                            usedGS=api.GS.findUsedItems(json),
                            donwload=(blob,name)=>{
                                let a=doc.createElement('a');
                                a.download = name;
                                a.rel = 'noopener';
                                a.href = URL.createObjectURL(blob);
                                setTimeout( ()=> { 
                                    URL.revokeObjectURL(a.href); 
                                    a=null;
                                },10000); 
                                a.click();
                                TF_Notification.showHide('warning',msgWrap,300);
                            };
                        json={builder_data:json};
                        if(customCss){
                            json.custom_css=customCss.trim();
                        }
                        if(usedGS){
                            const GS={};
                            for(let i=usedGS.length-1;i>-1;--i){
                                let gsItem=api.Helper.cloneObject(api.GS.styles[usedGS[i]]);
                                delete gsItem.id;
                                delete gsItem.url;
                                GS[usedGS[i]]=gsItem;
                            }
                            json.used_gs=GS;
                        }
                        json=JSON.stringify(json);
                        donwload(new Blob([json], {type: 'application/json'}),postTitle+'_themify_builder_export_'+currentData+'.txt');
                    }
                };

                msgWrap.innerHTML=themifyBuilder.i18n.offline;
                TF_Notification.show('warning',msgWrap);
                saveBtnCl.add('disabled');
                win.tfOn('online', ()=> {
                    saveBtnCl.remove('disabled');
                    TF_Notification.showHide('warning',msgWrap,300);
                    TF_Notification.el.tfOff(Themify.click,exportJson,{once:true});
                },{passive:true,once:true});
                
                TF_Notification.el.tfOn(Themify.click,exportJson,{once:true});
            }
        },3000);
    },{passive:true});
})(tb_app,Themify,document, window,TF_Notification,themifyBuilder);