(api => {
    'use strict';
    api.ModuleHighlight = class extends api.Module {
        constructor(fields) {
            super(fields);
        }
        static getOptions() {
            return [
                {
                    id: 'mod_title_highlight',
                    type: 'title'
                },
                {
                    id: 'layout_highlight',
                    type: 'layout',
                    label: 'playout',
                    mode: 'sprite',
                    post_grid: true
                },
                {
                    type: 'query_posts',
                    term_id: 'category_highlight',
                    slug_id: 'query_slug_highlight',
                    taxonomy: 'highlight-category'
                },
                {
                    id: 'post_per_page_highlight',
                    type: 'number',
                    label: 'npost',
                    help: 'nposth'
                },
                {
                    id: 'offset_highlight',
                    type: 'number',
                    label: 'ofs',
                    help: 'ofsh'
                },
                {
                    id: 'order_highlight',
                    type: 'select',
                    label: 'order',
                    help: 'ohelp',
                    order: true
                },
                {
                    id: 'orderby_highlight',
                    type: 'orderby_post',
                    binding: {
                        select: {
                            hide: 'meta_key_highlight'
                        },
                        meta_value: {
                            show: 'meta_key_highlight'
                        },
                        meta_value_num: {
                            show: 'meta_key_highlight'
                        }
                    }
                },
                {
                    id: 'meta_key_highlight',
                    type: 'text',
                    label: 'cfieldk'
                },
                {
                    id: 'display_highlight',
                    type: 'select',
                    label: 'disp',
                    options: {
                        content: 'content',
                        excerpt: 'excerpt',
                        none: 'none'
                    }
                },
                {
                    id: 'hide_feat_img_highlight',
                    type: 'toggle_switch',
                    label: 'fimg',
                    binding:{
                        checked:{show: ['image_size_highlight', 'img_width_highlight',  'img_height_highlight']},
                        not_checked:{hide: ['image_size_highlight', 'img_width_highlight', 'img_height_highlight']}
                    }
                },
                {
                    id: 'image_size_highlight',
                    type: 'image_size'
                },
                {
                    id: 'img_width_highlight',
                    type: 'number',
                    label: 'imgw'
                },
                {
                    id: 'img_height_highlight',
                    type: 'number',
                    label: 'imgh'
                },
                {
                    id: 'hide_post_title_highlight',
                    type: 'toggle_switch',
                    label: 'ptitle'
                },
                {
                    id: 'hide_page_nav_highlight',
                    type: 'toggle_switch',
                    label: 'pagin'
                },
                {
                    type: 'custom_css_id',
                    custom_css: 'css_highlight'
                }
            ];
        }
    };
})(tb_app);