((api, doc) => {
    'use strict';
    api.ModuleLogin = class extends api.Module {
        constructor(fields) {
            super(fields);
        }
        static getOptions() {
            return [
                {
                    id: 'mod_title',
                    type: 'title'
                },
                {
                    id: 'content_text',
                    type: 'textarea',
                    label: 'lginmsg',
                    help: 'lginmsgh',
                },
				{
					type: 'template_fields',
					title: 'avfields',
					target: 'content_text',
					fields: [
						'%username%',
						'%display_name%',
						'%first_name%',
						'%last_name%',
						'%email%',
					]
				},
                {
                    id: 'logout_link',
                    type: 'toggle_switch',
                    label: 'lgoutlnk',
                    options: {
                        on: {
                            name: 'show',
                            value: 's'
                        },
                        off: {
                            name: 'hide',
                            value: 'hi'
                        }
                    },
                    binding: {
                        hide: {
                            hide: 'logout_redirect'
                        },
                        show: {
                            show: 'logout_redirect'
                        }
                    }
                },
                {
                    id: 'logout_redirect',
                    type: 'url',
                    label: 'lgoutred',
                    control: false
                },
                {
                    id: 'alignment',
                    type: 'icon_radio',
                    label: 'falign',
                    aligment2: true
                },
                {
                    type: 'group',
                    label: 'lgform',
                    display: 'accordion',
                    options: [
                        {
                            id: 'redirect_to',
                            type: 'url',
                            label: 'rurl',
                            help: 'lgrurl',
                            control: false
                        },
                        {
                            id: 'fail_action',
                            type: 'select',
                            label: 'lgfail',
                            options: {
                                r: 'rwp',
                                c: 'rcust',
                                m: 'shmsg'
                            },
                            binding: {
                                r: {
                                    hide: [
                                        'redirect_fail',
                                        'msg_fail'
                                    ]
                                },
                                c: {
                                    show: 'redirect_fail',
                                    hide: 'msg_fail'
                                },
                                m: {
                                    hide: 'redirect_fail',
                                    show: 'msg_fail'
                                }
                            }
                        },
                        {
                            id: 'redirect_fail',
                            type: 'url',
                            label: 'rurlerr',
                            help: 'lgrurlaft',
                            control: false
                        },
                        {
                            id: 'msg_fail',
                            type: 'textarea',
                            label: 'failmsg',
                            after: 'lgfailmsg',
                            control: {
                                selector: '.tb_login_error'
                            }
                        },
                        {
                            type: 'multi',
                            label: 'labels',
                            options: [
                                {
                                    id: 'icon_username',
                                    type: 'icon'
                                },
                                {
                                    id: 'label_username',
                                    type: 'text',
                                    after: 'uname',
                                    control: {
                                        selector: '.tb_login_username_text'
                                    }
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'icon_password',
                                    type: 'icon'
                                },
                                {
                                    id: 'label_password',
                                    type: 'text',
                                    after: 'pswd',
                                    control: {
                                        selector: '.tb_login_password_text'
                                    }
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'icon_remember',
                                    type: 'icon'
                                },
                                {
                                    id: 'label_remember',
                                    type: 'text',
                                    after: 'rme',
                                    control: {
                                        selector: '.tb_login_remember_text'
                                    }
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'icon_log_in',
                                    type: 'icon'
                                },
                                {
                                    id: 'label_log_in',
                                    type: 'text',
                                    after: 'lgin',
                                    control: {
                                        selector: '.tb_login_submit button'
                                    }
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'icon_forgotten_password',
                                    type: 'icon'
                                },
                                {
                                    id: 'label_forgotten_password',
                                    type: 'text',
                                    after: 'fpswdlnk',
                                    control: {
                                        selector: '.tb_login_form .tb_login_links a'
                                    }
                                }
                            ]
                        },
                        {
                            id: 'remember_me_display',
                            type: 'toggle_switch',
                            label: 'rme',
                            default:'on',
                            options: {
                                on: {
                                    name: 'show',
                                    value: 's'
                                },
                                off: {
                                    name: 'hide',
                                    value: 'hi'
                                }
                            }
                        }
                    ]
                },
                {
                    type: 'group',
                    label: 'resetf',
                    display: 'accordion',
                    options: [
                        {
                            id: 'lostpasswordform_redirect_to',
                            type: 'url',
                            label: 'rurl',
                            help: 'rurlrstf',
                            control: false
                        },
                        {
                            type: 'multi',
                            label: 'labels',
                            options: [
                                {
                                    id: 'lostpasswordform_icon_username',
                                    type: 'icon'
                                },
                                {
                                    id: 'lostpasswordform_label_username',
                                    type: 'text',
                                    after: 'uname',
                                    control: {
                                        selector: '.tb_lostpassword_username_text'
                                    }
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'lostpasswordform_icon_reset',
                                    type: 'icon'
                                },
                                {
                                    id: 'lostpasswordform_label_reset',
                                    type: 'text',
                                    after: 'rpswdbtn',
                                    control: {
                                        selector: '.tb_lostpassword_submit button'
                                    }
                                }
                            ]
                        }
                    ]
                },
                {
                    type: 'custom_css_id',
                    custom_css: 'css'
                }
            ];
        }
        static default() {
            const lb = themifyBuilder.i18n.label;
            return {
                label_username: lb.unameemail,
                label_password: lb.pswd,
                label_remember: lb.rme,
                label_log_in: lb.lgin,
                label_forgotten_password: lb.fpswd,
                lostpasswordform_label_username: lb.unameemail,
                lostpasswordform_label_reset: lb.rpswd,
                msg_fail: lb.msgfail
            };
        }
        static builderSave(settings){
            const def={
                remember_me_display:'show',
                fail_action:'r',
                logout_link:'hide',
                alignment:'left'
            },
            failAction=settings.fail_action;
            for( let key in def){
                if(settings[key]===def[key]){
                    delete settings[key];
                }
            }
            if(settings.alignment==='undefined'){
                delete settings.alignment;
            }
            if(failAction!=='c'){
                delete settings.redirect_fail;
            }
            if(failAction!=='m'){
                delete settings.msg_fail;
            }
            super.builderSave(settings);
        }
        preview(data) {
            const module = doc.createElement('div'),
                wrap = doc.createElement('div'),
                loginForm=doc.createElement('form'),
                resetForm=doc.createElement('form'),
                loginLinks=doc.createElement('div'),
                forgotPswd=doc.createElement('a'),
                loginSubmit=doc.createElement('p'),
                loginBtn=doc.createElement('button'),
                lostPswdSubmit=doc.createElement('p'),
                lostPswdSubmitBtn=doc.createElement('button'),
                lostLoginLinksWrap=doc.createElement('div'),
                lostLoginLinks=doc.createElement('a'),
                classes = ['module', 'module-login'],
                alignment = !data.alignment || data.alignment==='undefined' ||'left' === data.alignment ? '' : ('center' === data.alignment?' tb_login_c':' tf_right'),
                getIcon=icon=>{
                    const em=doc.createElement('em');
                    em.appendChild(api.Helper.getIcon(icon));
                    return em;
                };
            if (data.css) {
                classes.push(data.css);
            }

            module.className = classes.join(' ');
            wrap.className = 'tb_login_wrap';
            if(alignment!==''){
                wrap.className+=' '+alignment;
            }
            
            loginForm.className='tb_login_form';
            loginForm.name='loginform';
            
            resetForm.className='tb_lostpassword_form';
            resetForm.name='lostpasswordform';
            
            
            
            if ( data.fail_action === 'm' ) {
                const error = doc.createElement('div');
                error.className='tb_login_error';
                this.setEditableContent(error,'msg_fail',data.msg_fail);
                loginForm.appendChild(error);
            }
            
            for(let i=0,items=['username','password','lostpassword_username'];i<items.length;++i){
                let k=items[i],
                    isLostpswd=k==='lostpassword_username',
                    p=doc.createElement('p'),
                    label=doc.createElement('label'),
                    text=doc.createElement('span'),
                    input=doc.createElement('input');
                
                p.className=isLostpswd?'tb_lostpassword_username':'tb_login_'+k;
                if(isLostpswd){
                    if(data.lostpasswordform_icon_username){
                        label.appendChild(getIcon(data.lostpasswordform_icon_username));
                    }
                }
                else if ( data['icon_'+k] ) {
                    label.appendChild(getIcon(data['icon_'+k]));
                }
                text.className=isLostpswd?'tb_lostpassword_username_text':'tb_login_'+k+'_text';
                this.setEditableContent(text,(isLostpswd?'lostpasswordform_label_username':'label_'+k),(isLostpswd?(data.lostpasswordform_label_username || ''):(data[ 'label_'+k] || '')));
                
                input.type=k==='password'?k:'text';
                input.className='input';
                input.name=k==='password'?'pwd':(isLostpswd?'user_login':'log');
                
                label.append(text,input);
                p.appendChild(label);
                if(isLostpswd){
                    resetForm.appendChild(p);
                    
                }else{
                    loginForm.appendChild(p);
                }
            }
            
            loginLinks.className='tb_login_links';
            if ( data.icon_forgotten_password ) {
                loginLinks.appendChild(getIcon(data.icon_forgotten_password));
            }
            forgotPswd.href='#';
            this.setEditableContent(forgotPswd,'label_forgotten_password',data.label_forgotten_password);
            
            loginLinks.appendChild(forgotPswd);
            
            loginForm.appendChild(loginLinks);
            
            if ( data.remember_me_display === 'show' ) {
                const p=doc.createElement('p'),
                    label=doc.createElement('label'),
                    text=doc.createElement('span'),
                    input=doc.createElement('input');
                    
                input.name='rememberme'; 
                input.type='checkbox'; 
                input.value=1;
                label.appendChild(input);
                
                if ( data.icon_remember ) {
                    label.appendChild(getIcon(data.icon_remember));
                }
                
                text.className='tb_login_remember_text';
                this.setEditableContent(text,'label_remember',data.label_remember);
                label.appendChild(text);
                
                p.className='tb_login_remember tf_left tf_box tf_clear';
                p.appendChild(label);
                
                loginForm.appendChild(p);
            }
            
            loginSubmit.className='tb_login_submit tf_right';
            this.setEditableContent(loginBtn,'label_log_in',data.label_log_in);
            if ( data.icon_log_in ) {
                loginBtn.prepend(getIcon(data.icon_log_in));
            }
            loginSubmit.appendChild(loginBtn);
            loginForm.appendChild(loginSubmit);
            
            //reset form
            lostPswdSubmit.className='tb_lostpassword_submit tf_right';
            this.setEditableContent(lostPswdSubmitBtn,'lostpasswordform_label_reset',data.lostpasswordform_label_reset);
            if ( data.lostpasswordform_icon_reset ) {
                lostPswdSubmitBtn.prepend(getIcon(data.lostpasswordform_icon_reset));
            }
            lostPswdSubmit.appendChild(lostPswdSubmitBtn);
            
            lostLoginLinksWrap.className='tb_login_links';
            lostLoginLinks.href='#';
            this.setEditableContent(lostLoginLinks,'label_log_in',data.label_log_in);
            
            lostLoginLinksWrap.appendChild(lostLoginLinks);
            
            resetForm.append(lostPswdSubmit,lostLoginLinksWrap);
            if (data.mod_title) {
                module.appendChild(this.getModuleTitle(data.mod_title,'mod_title'));
            }
            
            resetForm.style.display='none';
            wrap.append(loginForm,resetForm);
            module.appendChild(wrap);
            return module;
        }
    };
})(tb_app, document);