((api, doc) => {
    'use strict';
    api.ModuleLottie = class extends api.Module {
        constructor(fields) {
            super(fields);
        }
        static getOptions() {
            return [
                {
                    id: 'm_t',
                    type: 'title'
                },
                {
                    id: 'loop',
                    label: 'loopall',
                    type: 'toggle_switch',
                    default:'on',
                    options: {
                        on: {
                            name: '1',
                            value: 'y'
                        },
                        off: {
                            name:'0',
                            value: 'n'
                        }
                    }
                },
                {
                    type: 'builder',
                    id: 'actions',
                    options: [
                        {
                            type: 'lottie',
                            multi: 1
                        }
                    ]
                },
                {
                    type: 'custom_css_id',
                    custom_css: 'css'
                }
            ];
        }
        static builderSave(settings){
            const actions=settings.actions;
            if(settings.loop && parseInt(settings.loop)===1){
                delete settings.loop;
            }
            if(actions){
                for(let i=actions.length-1;i>-1;--i){
                    let act=actions[i];
                    if(!act.path){
                        actions.splice(i, 1); 
                    }else{
                        
                        if(act.delay<=0){
                            delete act.delay;
                        }
                        if(act.sp!==undefined && parseInt(act.sp)===1){
                            delete act.delay;
                        }
                    }
                }
            }
            super.builderSave(settings);
        }
        preview(data) {
            const module = doc.createElement('div'),
                    lottie = doc.createElement('tf-lottie'),
                    template=doc.createElement('template'),
                    classes = ['module', 'module-lottie'],
                    json={actions:(data.actions || [])};
            if (data.css) {
                classes.push(data.css);
            }
            if(data.loop && parseInt(data.loop)===1){
                json.loop=1;
            }
            module.className = classes.join(' ');
            if(data.m_t){
                module.appendChild(this.getModuleTitle(data.m_t,'m_t'));
            }
            template.innerHTML=JSON.stringify(json);
            lottie.appendChild(template);
            module.appendChild(lottie);
            return module;
        }
    };
})(tb_app, document);