((api,doc,themifyBuilder) => {
    'use strict';
    api.ModulePageBreak = class extends api.Module {
        constructor(fields) {
            super(fields);
        }
        preview(data) {
            const module = doc.createElement('div'),
                order = doc.createElement('span');
           
            module.className = 'module module-page-break';
            order.className = 'page-break-order';
            module.append(doc.createTextNode(themifyBuilder.i18n.label.pbreak),order);
            return module;
        }
        static countModules() {
            const builder=api.Builder.get().el,
                cl=api.isVisual?'module-page-break':'tb-page-break';
            for (let modules=builder.tfClass(cl),i = modules.length - 1; i > -1; --i) {
                if (api.isVisual) {
                    modules[i].tfClass('page-break-order')[0].textContent = (i + 1);
                } else {
                    modules[i].tfClass('page-break-overlay')[0].textContent = themifyBuilder.i18n.label.pbreak + (i + 1);
                }
            }
        }
        static cols() {
            return [{
                cols: [{
                    grid_class: 'col-full',
                    modules: [{
                        mod_name: 'page-break'
                    }]
                }],
                styling: {
                    custom_css_row: 'tb-page-break'
                }
            }];
        }
    };
})(tb_app,document,themifyBuilder);