(api => {
    'use strict';
    api.ModulePortfolio = class extends api.Module {
        constructor(fields) {
            super(fields);
        }
        static getOptions() {
            return [
                {
                    id: 'mod_title_portfolio',
                    type: 'title'
                },
                {
                    type: 'query_posts',
                    term_id: 'category_portfolio',
                    slug_id: 'query_slug_portfolio',
                    taxonomy: 'portfolio-category'
                },
                {
                    id: 'layout_portfolio',
                    type: 'layout',
                    label: 'playout',
                    control: {
                        classSelector: '.builder-posts-wrap'
                    },
                    mode: 'sprite',
                    post_grid: true
                },
                {
                    type:'post_filter'
                },
                {
                    id: 'post_per_page_portfolio',
                    type: 'number',
                    label: 'npost',
                    help: 'nposth'
                },
                {
                    id: 'offset_portfolio',
                    type: 'number',
                    label: 'ofs',
                    help: 'ofsh'
                },
                {
                    id: 'order_portfolio',
                    type: 'select',
                    label: 'order',
                    help: 'shelp',
                    order: true
                },
                {
                    id: 'orderby_portfolio',
                    type: 'orderby_post',
                    binding: {
                        select: {
                            hide: 'meta_key_portfolio'
                        },
                        meta_value: {
                            show: 'meta_key_portfolio'
                        },
                        meta_value_num: {
                            show: 'meta_key_portfolio'
                        }
                    }
                },
                {
                    id: 'meta_key_portfolio',
                    type: 'text',
                    label: 'cfieldk'
                },
                {
                    id: 'display_portfolio',
                    type: 'select',
                    label: 'disp',
                    options: {
                        content: 'content',
                        excerpt: 'excerpt',
                        none: 'none'
                    }
                },
                {
                    id: 'hide_feat_img_portfolio',
                    type: 'toggle_switch',
                    label: 'fimg',
                    binding: {
                        checked: {show: ['image_size_portfolio', 'img_width_portfolio', 'auto_fullwidth_portfolio', 'img_height_portfolio', 'unlink_feat_img_portfolio']},
                        not_checked: {hide: ['image_size_portfolio', 'img_width_portfolio', 'auto_fullwidth_portfolio', 'img_height_portfolio', 'unlink_feat_img_portfolio']}
                    }
                },
                {
                    id: 'image_size_portfolio',
                    type: 'image_size'
                },
                {
                    id: 'img_width_portfolio',
                    type: 'number',
                    label: 'imgw'
                },
                {
                    id: 'auto_fullwidth_portfolio',
                    type: 'checkbox',
                    label: '',
                    options: [
                        {
                            name: '1',
                            value: 'afullwimg'
                        }
                    ],
                    wrap_class: 'auto_fullwidth'
                },
                {
                    id: 'img_height_portfolio',
                    type: 'number',
                    label: 'imgh'
                },
                {
                    id: 'unlink_feat_img_portfolio',
                    type: 'toggle_switch',
                    label: 'unlfimg',
                    options: 'simple'
                },
                {
                    id: 'hide_post_title_portfolio',
                    type: 'toggle_switch',
                    label: 'ptitle',
                    binding: {
                        checked: {
                            show: [
                                'unlink_post_title_portfolio',
                                'title_tag_portfolio'
                            ]
                        },
                        not_checked: {
                            hide: [
                                'unlink_post_title_portfolio',
                                'title_tag_portfolio'
                            ]
                        }
                    }
                },
                {
                    id: 'title_tag_portfolio',
                    type: 'select',
                    label: 'tht',
                    h_tags: true,
                    default: 'h2'
                },
                {
                    id: 'unlink_post_title_portfolio',
                    type: 'toggle_switch',
                    label: 'uptitle',
                    options: 'simple'
                },
                {
                    id: 'hide_post_date_portfolio',
                    type: 'toggle_switch',
                    label: 'pdate'
                },
                {
                    id: 'hide_post_meta_portfolio',
                    type: 'toggle_switch',
                    label: 'pmeta'
                },
                {
                    id: 'hide_page_nav_portfolio',
                    type: 'toggle_switch',
                    label: 'pagin',
                    binding: {
                        checked: {
                            show: 'nav_type'
                        },
                        not_checked: {
                            hide: 'nav_type'
                        }
                    }
                },
                {
                    id: 'nav_type',
                    type: 'select',
                    label: 'pagint',
                    options: {
                        standard: 'standard',
                        ajax: 'lmore'
                    }
                },
                {
                    id: 'hide_empty',
                    type: 'toggle_switch',
                    label: 'hempmod',
                    help: 'hempmodh',
                    options: 'simple'
                },
                {
                    type: 'custom_css_id',
                    custom_css: 'css_portfolio'
                }
            ];
        }
        static default() {
            return {
                layout_portfolio: 'grid4',
                post_per_page_portfolio: 4,
                hide_page_nav_portfolio: 'yes',
                display_portfolio: 'excerpt'
            };
        }
    };
})(tb_app);