((api, doc) => {
    'use strict';
    api.ModuleSignupForm = class extends api.Module {
        constructor(fields) {
            super(fields);
        }
        static getOptions() {
            return [
                {
                    id: 'mod_title',
                    type: 'title'
                },
                {
                    id: 'e_user',
                    type: 'checkbox',
                    default:'1',
                    label: '',
                    options: [
                        {
                            name: '1',
                            value: 'sacinftus'
                        }
                    ]
                },
                {
                    id: 'e_admin',
                    type: 'checkbox',
                    default:'1',
                    label: '',
                    options: [
                        {
                            name: '1',
                            value: 'sacinftadm'
                        }
                    ]
                },
                {
                    type: 'separator',
                    label: ''
                },
                {
                    id: 'success_action',
                    type: 'select',
                    label: 'afsign',
                    options: {
                        c: 'rtourl',
                        m: 'shmsg'
                    },
                    binding: {
                        c: {
                            show: 'redirect_to',
                            hide: 'msg_success'
                        },
                        m: {
                            hide: 'redirect_to',
                            show: 'msg_success'
                        }
                    }
                },
                {
                    id: 'redirect_to',
                    type: 'url',
                    label: 'rurl',
                    help: 'rurlafsign'
                },
                {
                    id: 'msg_success',
                    type: 'textarea',
                    label: 'sucmsg',
                    help: 'smsgafsign'
                },
                {
                    id: 'optin',
                    type: 'toggle_switch',
                    label: 'nwsletopt',
                    default:'off',
                    options: {
                        on: {
                            name: 'yes',
                            value: 'en'
                        },
                        off: {
                            name: 'no',
                            value: 'dis'
                        }
                    },
                    binding: {
                        yes: {
                            show: [
                                'optin_label',
                                'provider'
                            ]
                        },
                        no: {
                            hide: [
                                'optin_label',
                                'provider'
                            ]
                        }
                    }
                },
                {
                    id: 'optin_label',
                    type: 'text',
                    label: 'sbscrbelb'
                },
                {
                    id: 'provider',
                    label: 'Provider',
                    type: 'optin_provider'
                },
                {
                    id: 'gdpr',
                    label: 'gdpr',
                    type: 'toggle_switch',
                    options: {
                        on: {
                            name: 'on',
                            value: 'en'
                        },
                        off: {
                            name: '',
                            value: 'dis'
                        }
                    },
                    binding: {
                        checked: {
                            show: 'gdpr_label'
                        },
                        not_checked: {
                            hide: 'gdpr_label'
                        }
                    }
                },
				{
					id : 'captcha',
					type : 'select',
					label : 'cptch',
					help : 'cptchh',
					options : {
						'' : '',
						'recaptcha' : 'recptch',
						'hcaptcha': 'hcptch'
					}
				},
                {
                    id: 'welcome',
                    type: 'textarea',
                    label: 'welcmsg'
                },
                {
                    type: 'template_fields',
                    target: 'welcome',
                    fields: [
                        '%site_name%',
                        '%site_description%',
                        '%site_url%',
                        '%user_login%',
                        '%user_email%',
                        '%user_firstname%',
                        '%user_lastname%',
                        '%user_display_name%',
                        '%user_id%'
                    ],
                    title: 'avfields'
                },
                {
                    id: 'gdpr_label',
                    type: 'textarea',
                    label: 'gdpr_msg'
                },
                {
                    type: 'group',
                    label: 'labels',
                    display: 'accordion',
                    options: [
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_name',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_name',
                                    type: 'text',
                                    label: 'name'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_firstname',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_firstname',
                                    type: 'text',
                                    label: 'fname'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_lastname',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_lastname',
                                    type: 'text',
                                    label: 'lname'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_username',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_username',
                                    type: 'text',
                                    label: 'uname'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_email',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_email',
                                    type: 'text',
                                    label: 'em'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_password',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_password',
                                    type: 'text',
                                    label: 'pswd'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_bio',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_bio',
                                    type: 'textarea',
                                    label: 'bio'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_submit',
                                    type: 'icon'
                                },
                                {
                                    id: 'l_submit',
                                    type: 'text',
                                    label: 'submit'
                                }
                            ]
                        },
                        {
                            type: 'multi',
                            label: '',
                            options: [
                                {
                                    id: 'i_desc',
                                    type: 'icon'
                                },
                                {
                                    id: 'desc',
                                    type: 'textarea',
                                    label: 'desc'
                                }
                            ]
                        }
                    ]
                },
                {
                    type: 'custom_css_id',
                    custom_css: 'css'
                }
            ];
        }
        static default() {
            const lb = themifyBuilder.i18n.label;
            return {
                l_name: lb.name,
                l_firstname: lb.fname,
                l_lastname: lb.lname,
                l_username: lb.uname,
                l_email: lb.em,
                l_password: lb.pswd,
                l_bio: lb.sbio,
                l_submit: lb.submit,
                desc: lb.shrltinf,
                u_role: lb.subscriber,
                optin_label: lb.sbscrbenws,
                gdpr_label: lb.gdpr_opt_msg
            };
        }
        static builderSave(settings) {
            const def = {
                success_action: 'c',
                optin: 'no',
                u_role: 'subscriber',
                e_user:'1',
                e_admin:'1'
            };
            for (let key in def) {
                if (settings[key] === def[key]) {
                    delete settings[key];
                }
            }
            if (settings.success_action && settings.success_action!=='c') {
                delete settings.redirect_to;
            }
            if (settings.success_action!=='m') {
                delete settings.msg_success;
            }
            if(!settings.gdpr){
                delete settings.gdpr_label;
            }
            if(settings.optin!=='yes'){
                delete settings.optin_label;
                delete settings.provider;
            }
            if(!settings.desc){
                delete settings.i_desc;
            }
            super.builderSave(settings);
        }
        preview(data) {
            const module = doc.createElement('div'),
                    form = doc.createElement('form'),
                    divWarp=doc.createElement('div'),
                    lNameLabel=doc.createElement('label'),
                    lName=doc.createElement('span'),
                    spWrap=doc.createElement('div'),
                    submit = doc.createElement('button'),
                    classes = ['module', 'module-signup-form'],
                    spanClass='tb_signup_label',
                    getIcon=ic=>{
                        const em=doc.createElement('em');
                        em.appendChild(api.Helper.getIcon(ic));
                        return em;
                    };
            if (data.css) {
                classes.push(data.css);
            }
            module.className = classes.join(' ');
            form.className=form.name = 'tb_signup_form';
            
            lName.className=spanClass;
            this.setEditableContent(lName,'l_name',data.l_name);
            
            if ( data.i_name ) {
                lName.prepend(getIcon(data.i_name));
            }
            lNameLabel.appendChild(lName);
            
            spWrap.className='tb_sp_name_wrapper';
            for(let fields=[{n:'first_n',k:'firstname'},{n:'last_n',k:'lastname'}],i=0;i<fields.length;++i){
                let d = doc.createElement('div'),
                    label=doc.createElement('label'),
                    input = doc.createElement('input'),
                    span=doc.createElement('span'),
                    key=fields[i].k;
                input.type='text';
                input.name=fields[i].n;
                this.setEditableContent(span,'l_'+key,data['l_'+key]);
                if ( data['i_'+key] ) {
                    span.prepend(getIcon(data['i_'+key]));
                }
                label.append(input,span);
                d.appendChild(label);
                spWrap.appendChild(d);
            }
            
            divWarp.append(lNameLabel,spWrap);
            form.appendChild(divWarp);
            
            for(let fields=[{n:'usr',k:'username'},{n:'email',k:'email'},{n:'pwd',k:'password'},{n:'bio',k:'bio'}],i=0;i<fields.length;++i){
                let key=fields[i].k,
                    d = doc.createElement('div'),
                    label=doc.createElement('label'),
                    input =key==='bio'? doc.createElement('textarea'): doc.createElement('input'),
                    span=doc.createElement('span');
                
                label.append(span,input);
                d.appendChild(label);
                if(key!=='bio'){
                    input.type=key==='password' || key==='email'?key:'text';
                    if(key==='password'){
                        input.autocomplete='current-password';
                    }
                    span.dataset.required='yes';
                }
                else if (data.desc ) {
                    let p=doc.createElement('p');
                    p.textContent=data.desc;
                    if ( data.i_desc ) {
                        p.prepend(getIcon(data.i_desc));
                    }
                    d.appendChild(p);
                }
                input.name=fields[i].n;
                span.className=spanClass;
                this.setEditableContent(span,'l_'+key,data['l_'+key]);
                if ( data['i_'+key] ) {
                    span.prepend(getIcon(data['i_'+key]));
                }
                form.appendChild(d);
            }
            if (  data.optin==='yes' ||  data.gdpr==='on') {
                const fields = [];
                if(data.optin==='yes'){
                    fields.push({n:'optin',k:'optin_label'});
                }
                if(data.gdpr==='on'){
                    fields.push({n:'gdpr',k:'gdpr_label'});
                }
                for(let i=0;i<fields.length;++i){
                    let key=fields[i].k,
                    d = doc.createElement('div'),
                    label=doc.createElement('label'),
                    input =doc.createElement('input'),
                    span=doc.createElement('span');
                    
                    input.type='checkbox';
                    input.name=fields[i].n;
                    if(key==='gdpr_label'){
                        input.required=1;
                    }
                    span.className='tb_signup_'+fields[i].n;
                    this.setEditableContent(span,key,data[key]);
                    
                    label.append(input,span);
                    d.appendChild(label);
                    form.appendChild(d); 
                }
            }
            
            submit.name='tb_submit';
            this.setEditableContent(submit,'l_submit',data.l_submit);
            if(data.i_submit){
                submit.prepend(getIcon(data.i_submit));
            }
            form.appendChild(submit); 
            if (data.mod_title) {
                module.appendChild(this.getModuleTitle(data.mod_title, 'mod_title'));
            }
            module.appendChild(form);
            return module;
        }
    };
})(tb_app, document);