<?php
defined('ABSPATH') || exit;

/**
 * Module Name: Accordion
 * Description: Display Accordion content
 */
class TB_Accordion_Module extends Themify_Builder_Component_Module {

	public static function get_module_name():string {
		return __('Accordion', 'themify');
	}

	public static function get_module_icon():string {
		return 'layout-accordion-merged';
	}

	public static function get_js_css():array {
		return array(
			'css' => 1,
			'js' => 1
		);
	}
	/**
	 * Render plain content for static content.
	 * 
	 * @param array $module 
	 * @return string
	 */
	public static function get_static_content(array $module):string {
		$mod_settings = $module['mod_settings']+array(
			'mod_title_accordion' => '',
			'content_accordion' => array()
		);
		$text = '';

		if ('' !== $mod_settings['mod_title_accordion'])
			$text = sprintf('<h3>%s</h3>', $mod_settings['mod_title_accordion']);

		if (!empty($mod_settings['content_accordion'])) {
			$text .= '<ul>';
			foreach ($mod_settings['content_accordion'] as $accordion) {
				if(isset($content['text_accordion'])){
					$title=isset($content['title_accordion'])?$content['title_accordion']:'';
					$text .= sprintf('<li><h4>%s</h4>%s</li>', $title, $accordion['text_accordion']);
				}
				
			}
			$text .= '</ul>';
		}
		return $text;
	}
}
